package com.loafle.totopia.member.model;

import com.fasterxml.jackson.annotation.JsonIgnore;

import javax.persistence.*;
import java.util.Objects;

@Entity
@Table(name = "tbl_member")
public class Member {

  private long memberSrl;
  private String userId;
  private String emailAddress;
  private String password;
  private String emailId;
  private String emailHost;
  private String userName;
  private String nickName;
  private Long findAccountQuestion;
  private String findAccountAnswer;
  private String homepage;
  private String blog;
  private String birthday;
  private String allowMailing;
  private String allowMessage;
  private String denied;
  private String limitDate;
  private String regdate;
  private String lastLogin;
  private String changePasswordDate;
  private String isAdmin;
  private String description;
  private String extraVars;
  private long listOrder;

  public Member() {
  }

  @Id
  @Column(name = "member_srl", nullable = false)
  public long getMemberSrl() {
    return memberSrl;
  }

  public void setMemberSrl(long memberSrl) {
    this.memberSrl = memberSrl;
  }

  @Basic
  @Column(name = "user_id", nullable = false, length = 80)
  public String getUserId() {
    return userId;
  }

  public void setUserId(String userId) {
    this.userId = userId;
  }

  @Basic
  @Column(name = "email_address", nullable = false, length = 250)
  public String getEmailAddress() {
    return emailAddress;
  }

  public void setEmailAddress(String emailAddress) {
    this.emailAddress = emailAddress;
  }

  @Basic
  @JsonIgnore
  @Column(name = "password", nullable = false, length = 60)
  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    this.password = password;
  }

  @Basic
  @Column(name = "email_id", nullable = false, length = 80)
  public String getEmailId() {
    return emailId;
  }

  public void setEmailId(String emailId) {
    this.emailId = emailId;
  }

  @Basic
  @Column(name = "email_host", nullable = true, length = 160)
  public String getEmailHost() {
    return emailHost;
  }

  public void setEmailHost(String emailHost) {
    this.emailHost = emailHost;
  }

  @Basic
  @Column(name = "user_name", nullable = false, length = 40)
  public String getUserName() {
    return userName;
  }

  public void setUserName(String userName) {
    this.userName = userName;
  }

  @Basic
  @Column(name = "nick_name", nullable = false, length = 40)
  public String getNickName() {
    return nickName;
  }

  public void setNickName(String nickName) {
    this.nickName = nickName;
  }

  @Basic
  @Column(name = "find_account_question", nullable = true)
  public Long getFindAccountQuestion() {
    return findAccountQuestion;
  }

  public void setFindAccountQuestion(Long findAccountQuestion) {
    this.findAccountQuestion = findAccountQuestion;
  }

  @Basic
  @Column(name = "find_account_answer", nullable = true, length = 250)
  public String getFindAccountAnswer() {
    return findAccountAnswer;
  }

  public void setFindAccountAnswer(String findAccountAnswer) {
    this.findAccountAnswer = findAccountAnswer;
  }

  @Basic
  @Column(name = "homepage", nullable = true, length = 250)
  public String getHomepage() {
    return homepage;
  }

  public void setHomepage(String homepage) {
    this.homepage = homepage;
  }

  @Basic
  @Column(name = "blog", nullable = true, length = 250)
  public String getBlog() {
    return blog;
  }

  public void setBlog(String blog) {
    this.blog = blog;
  }

  @Basic
  @Column(name = "birthday", nullable = true, length = 8)
  public String getBirthday() {
    return birthday;
  }

  public void setBirthday(String birthday) {
    this.birthday = birthday;
  }

  @Basic
  @Column(name = "allow_mailing", nullable = false, length = 1)
  public String getAllowMailing() {
    return allowMailing;
  }

  public void setAllowMailing(String allowMailing) {
    this.allowMailing = allowMailing;
  }

  @Basic
  @Column(name = "allow_message", nullable = false, length = 1)
  public String getAllowMessage() {
    return allowMessage;
  }

  public void setAllowMessage(String allowMessage) {
    this.allowMessage = allowMessage;
  }

  @Basic
  @Column(name = "denied", nullable = true, length = 1)
  public String getDenied() {
    return denied;
  }

  public void setDenied(String denied) {
    this.denied = denied;
  }

  @Basic
  @Column(name = "limit_date", nullable = true, length = 14)
  public String getLimitDate() {
    return limitDate;
  }

  public void setLimitDate(String limitDate) {
    this.limitDate = limitDate;
  }

  @Basic
  @Column(name = "regdate", nullable = true, length = 14)
  public String getRegdate() {
    return regdate;
  }

  public void setRegdate(String regdate) {
    this.regdate = regdate;
  }

  @Basic
  @Column(name = "last_login", nullable = true, length = 14)
  public String getLastLogin() {
    return lastLogin;
  }

  public void setLastLogin(String lastLogin) {
    this.lastLogin = lastLogin;
  }

  @Basic
  @Column(name = "change_password_date", nullable = true, length = 14)
  public String getChangePasswordDate() {
    return changePasswordDate;
  }

  public void setChangePasswordDate(String changePasswordDate) {
    this.changePasswordDate = changePasswordDate;
  }

  @Basic
  @Column(name = "is_admin", nullable = true, length = 1)
  public String getIsAdmin() {
    return isAdmin;
  }

  public void setIsAdmin(String isAdmin) {
    this.isAdmin = isAdmin;
  }

  @Basic
  @Column(name = "description", columnDefinition = "text") // nullable = true, length = -1
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  @Basic
  @Column(name = "extra_vars", columnDefinition = "text") // nullable = true, length = -1
  public String getExtraVars() {
    return extraVars;
  }

  public void setExtraVars(String extraVars) {
    this.extraVars = extraVars;
  }

  @Basic
  @Column(name = "list_order", nullable = false)
  public long getListOrder() {
    return listOrder;
  }

  public void setListOrder(long listOrder) {
    this.listOrder = listOrder;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o)
      return true;
    if (o == null || getClass() != o.getClass())
      return false;
    Member xeMember = (Member) o;
    return memberSrl == xeMember.memberSrl && listOrder == xeMember.listOrder && Objects.equals(userId, xeMember.userId)
        && Objects.equals(emailAddress, xeMember.emailAddress) && Objects.equals(password, xeMember.password)
        && Objects.equals(emailId, xeMember.emailId) && Objects.equals(emailHost, xeMember.emailHost)
        && Objects.equals(userName, xeMember.userName) && Objects.equals(nickName, xeMember.nickName)
        && Objects.equals(findAccountQuestion, xeMember.findAccountQuestion)
        && Objects.equals(findAccountAnswer, xeMember.findAccountAnswer) && Objects.equals(homepage, xeMember.homepage)
        && Objects.equals(blog, xeMember.blog) && Objects.equals(birthday, xeMember.birthday)
        && Objects.equals(allowMailing, xeMember.allowMailing) && Objects.equals(allowMessage, xeMember.allowMessage)
        && Objects.equals(denied, xeMember.denied) && Objects.equals(limitDate, xeMember.limitDate)
        && Objects.equals(regdate, xeMember.regdate) && Objects.equals(lastLogin, xeMember.lastLogin)
        && Objects.equals(changePasswordDate, xeMember.changePasswordDate) && Objects.equals(isAdmin, xeMember.isAdmin)
        && Objects.equals(description, xeMember.description) && Objects.equals(extraVars, xeMember.extraVars);
  }

  @Override
  public int hashCode() {
    return Objects.hash(memberSrl, userId, emailAddress, password, emailId, emailHost, userName, nickName,
        findAccountQuestion, findAccountAnswer, homepage, blog, birthday, allowMailing, allowMessage, denied, limitDate,
        regdate, lastLogin, changePasswordDate, isAdmin, description, extraVars, listOrder);
  }

}